
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny2313
;Program type             : Application
;Clock frequency          : 4,000000 MHz
;Memory model             : Tiny
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 32 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _hour=R3
	.DEF _minuti=R2
	.DEF _second=R5
	.DEF _temp=R4
	.DEF _catod=R7
	.DEF _regim=R6
	.DEF _regimA=R9
	.DEF _date=R8
	.DEF _month=R11
	.DEF _year=R10
	.DEF _hor=R13
	.DEF _min=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0xD8:
	.DB  0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0
	.DB  0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x0C
	.DW  0x02
	.DW  _0xD8*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,0x00
	OUT  GPIOR0,R30
	OUT  GPIOR1,R30
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : CLOC
;Version :
;Date    : 20.02.2011
;Author  : NeVaDa
;Company : RUSSIA
;Comments:
;
;
;Chip type               : ATtiny2313
;AVR Core Clock frequency: 4,000000 MHz
;Memory model            : Tiny
;External RAM size       : 0
;Data Stack size         : 32
;*****************************************************/
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
; #asm
.equ __i2c_port=0x18
.equ __sda_bit=3
.equ __scl_bit=2
; 0000 001C #endasm
;#include <ds1307.h>
;#include <bcd.h>
;#include <delay.h>
;#define    Out  PORTD.6    // Speaker
;eeprom unsigned char tabkod[13]={0b10000011,0b10100011,0b10110011,0b00010011,0b00100011,0b01100011,0b01000011,0b00000011,0b00110011,0b10010011,0,0}; // :     2     
;
;unsigned char hour=0,minuti=0,second=0,temp=0,catod=1;
;unsigned char regim=0,regimA=0;
;unsigned char date=0,month=0,year=0;
;unsigned char hor=0,min=0,sec=0;
;unsigned int  count=0;
;bit mig=0,mig1=0,mig2=0;
;bit Play=0;
;unsigned char bufer;
;
;
;unsigned  int    T1Reload=0;
;unsigned int    index=0;
;unsigned  int     lang=0;
;
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIMER0_COMPA] void timer0_compa_isr (void)
; 0000 0034 {

	.CSEG
_timer0_compa_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0035 unsigned char sek1,sek10,min1,min10,has1,has10;
; 0000 0036 // Place your code here
; 0000 0037        temp=bin2bcd(sec);
	RCALL __SAVELOCR6
;	sek1 -> R17
;	sek10 -> R16
;	min1 -> R19
;	min10 -> R18
;	has1 -> R21
;	has10 -> R20
	LDS  R30,_sec
	RCALL SUBOPT_0x0
	MOV  R4,R30
; 0000 0038        sek1=temp;
	MOV  R17,R4
; 0000 0039        sek1&=0b00001111;
	ANDI R17,LOW(15)
; 0000 003A        temp&=0b11110000;
	RCALL SUBOPT_0x1
; 0000 003B        sek10=temp>>4;
	MOV  R16,R30
; 0000 003C 
; 0000 003D        temp=bin2bcd(min);
	ST   -Y,R12
	RCALL _bin2bcd
	MOV  R4,R30
; 0000 003E        min1=temp;
	MOV  R19,R4
; 0000 003F        min1&=0b00001111;
	ANDI R19,LOW(15)
; 0000 0040        temp&=0b11110000;
	RCALL SUBOPT_0x1
; 0000 0041        min10=temp>>4;
	MOV  R18,R30
; 0000 0042 
; 0000 0043        temp=bin2bcd(hor);
	ST   -Y,R13
	RCALL _bin2bcd
	MOV  R4,R30
; 0000 0044        has1=temp;
	MOV  R21,R4
; 0000 0045        has1&=0b00001111;
	ANDI R21,LOW(15)
; 0000 0046        temp&=0b11110000;
	RCALL SUBOPT_0x1
; 0000 0047        has10=temp>>4;
	MOV  R20,R30
; 0000 0048 
; 0000 0049 PORTD.5=1;PORTD.4=1;PORTD.3=1;PORTD.2=1;PORTD.1=1;PORTD.0=1;
	SBI  0x12,5
	SBI  0x12,4
	SBI  0x12,3
	SBI  0x12,2
	SBI  0x12,1
	SBI  0x12,0
; 0000 004A 
; 0000 004B  if(mig==0)
	SBIC 0x13,0
	RJMP _0xF
; 0000 004C   {
; 0000 004D   if(catod==32) {PORTD.5=0,PORTB=tabkod[has10];}
	LDI  R30,LOW(32)
	CP   R30,R7
	BRNE _0x10
	CBI  0x12,5
	MOV  R26,R20
	RCALL SUBOPT_0x2
; 0000 004E   if(catod==16) {PORTD.4=0,PORTB=tabkod[has1];}
_0x10:
	LDI  R30,LOW(16)
	CP   R30,R7
	BRNE _0x13
	CBI  0x12,4
	MOV  R26,R21
	RCALL SUBOPT_0x2
; 0000 004F   }
_0x13:
; 0000 0050   else //  
	RJMP _0x16
_0xF:
; 0000 0051   {
; 0000 0052   if(catod==32) {PORTD=127;}
	LDI  R30,LOW(32)
	CP   R30,R7
	BRNE _0x17
	RCALL SUBOPT_0x3
; 0000 0053   if(catod==16) {PORTD=127;}
_0x17:
	LDI  R30,LOW(16)
	CP   R30,R7
	BRNE _0x18
	RCALL SUBOPT_0x3
; 0000 0054   }
_0x18:
_0x16:
; 0000 0055  if(mig1==0)
	SBIC 0x13,1
	RJMP _0x19
; 0000 0056   {
; 0000 0057   if(catod==8) {PORTD.3=0,PORTB=tabkod[min10];}
	LDI  R30,LOW(8)
	CP   R30,R7
	BRNE _0x1A
	CBI  0x12,3
	MOV  R26,R18
	RCALL SUBOPT_0x2
; 0000 0058   if(catod==4) {PORTD.2=0,PORTB=tabkod[min1];}
_0x1A:
	LDI  R30,LOW(4)
	CP   R30,R7
	BRNE _0x1D
	CBI  0x12,2
	MOV  R26,R19
	RCALL SUBOPT_0x2
; 0000 0059   }
_0x1D:
; 0000 005A   else  //  
	RJMP _0x20
_0x19:
; 0000 005B   {
; 0000 005C   if(catod==8) {PORTD=127;}
	LDI  R30,LOW(8)
	CP   R30,R7
	BRNE _0x21
	RCALL SUBOPT_0x3
; 0000 005D   if(catod==4) {PORTD=127;}
_0x21:
	LDI  R30,LOW(4)
	CP   R30,R7
	BRNE _0x22
	RCALL SUBOPT_0x3
; 0000 005E   }
_0x22:
_0x20:
; 0000 005F  if(mig2==0)
	SBIC 0x13,2
	RJMP _0x23
; 0000 0060   {
; 0000 0061   if(catod==2) {PORTD.1=0,PORTB=tabkod[sek10];}
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x24
	CBI  0x12,1
	MOV  R26,R16
	RCALL SUBOPT_0x2
; 0000 0062   if(catod==1) {PORTD.0=0,PORTB=tabkod[sek1];}
_0x24:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x27
	CBI  0x12,0
	MOV  R26,R17
	RCALL SUBOPT_0x2
; 0000 0063   }
_0x27:
; 0000 0064   else  //  
	RJMP _0x2A
_0x23:
; 0000 0065   {
; 0000 0066   if(catod==2) {PORTD=127;}
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x2B
	RCALL SUBOPT_0x3
; 0000 0067   if(catod==1) {PORTD=127;}
_0x2B:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x2C
	RCALL SUBOPT_0x3
; 0000 0068   }
_0x2C:
_0x2A:
; 0000 0069 catod<<=1;
	LSL  R7
; 0000 006A if(catod==64){catod=1;}
	LDI  R30,LOW(64)
	CP   R30,R7
	BRNE _0x2D
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 006B     return;
_0x2D:
	RCALL __LOADLOCR6
	ADIW R28,6
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; 0000 006C }
;
;void main(void)
; 0000 006F {
_main:
; 0000 0070 {
; 0000 0071 // Crystal Oscillator division factor: 1
; 0000 0072 #pragma optsize-
; 0000 0073 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 0074 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0075 #ifdef _OPTIMIZE_SIZE_
; 0000 0076 #pragma optsize+
; 0000 0077 #endif
; 0000 0078 // Port B initialization
; 0000 0079 PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 007A DDRB=0xFC;
	LDI  R30,LOW(252)
	OUT  0x17,R30
; 0000 007B // Port D initialization
; 0000 007C PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 007D DDRD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x11,R30
; 0000 007E // Timer/Counter 0 initialization
; 0000 007F     TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0080     TCCR0B=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 0081     OCR0A=250;
	LDI  R30,LOW(250)
	OUT  0x36,R30
; 0000 0082 
; 0000 0083  TIMSK=0b00000001;
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 0084 // Universal Serial Interface initialization
; 0000 0085 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0086 // Global enable interrupts
; 0000 0087 #asm("sei")
	sei
; 0000 0088 }
; 0000 0089      i2c_init();
	RCALL _i2c_init
; 0000 008A      rtc_init(0,0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _rtc_init
; 0000 008B      rtc_get_date(&date,&month,&year);
	RCALL SUBOPT_0x5
; 0000 008C while (1)
_0x2E:
; 0000 008D  {
; 0000 008E 
; 0000 008F     if(Play==1)//   
	SBIS 0x13,3
	RJMP _0x31
; 0000 0090      {
; 0000 0091       if(lang!=15){if(T1Reload==0){Out=!Out;T1Reload=4000;lang++;}}
	LDS  R26,_lang
	LDS  R27,_lang+1
	SBIW R26,15
	BREQ _0x32
	LDS  R30,_T1Reload
	LDS  R31,_T1Reload+1
	SBIW R30,0
	BRNE _0x33
	SBIS 0x12,6
	RJMP _0x34
	CBI  0x12,6
	RJMP _0x35
_0x34:
	SBI  0x12,6
_0x35:
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	STS  _T1Reload,R30
	STS  _T1Reload+1,R31
	LDI  R26,LOW(_lang)
	RCALL SUBOPT_0x6
_0x33:
; 0000 0092       else{if(index!=4000){index++;Out=1;}else{index=0;lang=0;}}
	RJMP _0x36
_0x32:
	LDS  R26,_index
	LDS  R27,_index+1
	CPI  R26,LOW(0xFA0)
	LDI  R30,HIGH(0xFA0)
	CPC  R27,R30
	BREQ _0x37
	LDI  R26,LOW(_index)
	RCALL SUBOPT_0x6
	SBI  0x12,6
	RJMP _0x3A
_0x37:
	RCALL SUBOPT_0x7
	LDI  R30,LOW(0)
	STS  _lang,R30
	STS  _lang+1,R30
_0x3A:
_0x36:
; 0000 0093      }
; 0000 0094      else {index = 0;Out = 1;}
	RJMP _0x3B
_0x31:
	RCALL SUBOPT_0x7
	SBI  0x12,6
_0x3B:
; 0000 0095 
; 0000 0096      count++;
	LDI  R26,LOW(_count)
	RCALL SUBOPT_0x6
; 0000 0097      while(count==22000)
	LDS  R26,_count
	LDS  R27,_count+1
	CPI  R26,LOW(0x55F0)
	LDI  R30,HIGH(0x55F0)
	CPC  R27,R30
	BREQ PC+2
	RJMP _0x40
; 0000 0098      {
; 0000 0099        if(PINB.0==0&PINB.1==0)   //  
	RCALL SUBOPT_0x8
	BREQ _0x41
; 0000 009A        {
; 0000 009B         if(regim==3){regim=0;}      //  
	LDI  R30,LOW(3)
	CP   R30,R6
	BRNE _0x42
	CLR  R6
; 0000 009C         else{regim++;}
	RJMP _0x43
_0x42:
	INC  R6
_0x43:
; 0000 009D         regimA=0;bufer=0;
	CLR  R9
	RCALL SUBOPT_0x9
; 0000 009E         while(PINB.0==0&PINB.1==0){} //   
_0x44:
	RCALL SUBOPT_0x8
	BRNE _0x44
; 0000 009F        }
; 0000 00A0        if(PINB.0==1&PINB.1==0&mig==mig1==mig2)   // 
_0x41:
	RCALL SUBOPT_0xA
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R0,R30
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	LDI  R30,0
	SBIC 0x13,1
	LDI  R30,1
	RCALL __EQB12
	MOV  R26,R30
	LDI  R30,0
	SBIC 0x13,2
	LDI  R30,1
	LDI  R27,0
	SBRC R26,7
	SER  R27
	RCALL SUBOPT_0xC
	RCALL __EQW12
	AND  R30,R0
	BREQ _0x47
; 0000 00A1        {
; 0000 00A2          if(regim==0){Play=0;}
	TST  R6
	BRNE _0x48
	CBI  0x13,3
; 0000 00A3          bufer++;
_0x48:
	RCALL SUBOPT_0xD
	SUBI R30,-LOW(1)
	STS  _bufer,R30
; 0000 00A4          if(regim==1 || regim==2)
	LDI  R30,LOW(1)
	CP   R30,R6
	BREQ _0x4C
	LDI  R30,LOW(2)
	CP   R30,R6
	BRNE _0x4B
_0x4C:
; 0000 00A5           {
; 0000 00A6           if(regimA==1){if(bufer>=60){bufer=0;}}
	LDI  R30,LOW(1)
	CP   R30,R9
	BRNE _0x4E
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x3C)
	BRLO _0x4F
	RCALL SUBOPT_0x9
_0x4F:
; 0000 00A7           if(regimA==2){if(bufer>=24){bufer=0;}}
_0x4E:
	LDI  R30,LOW(2)
	CP   R30,R9
	BRNE _0x50
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x18)
	BRLO _0x51
	RCALL SUBOPT_0x9
_0x51:
; 0000 00A8           if(regimA==3){regimA=0;}
_0x50:
	LDI  R30,LOW(3)
	CP   R30,R9
	BRNE _0x52
	CLR  R9
; 0000 00A9           }
_0x52:
; 0000 00AA 
; 0000 00AB            if(regim==3)
_0x4B:
	LDI  R30,LOW(3)
	CP   R30,R6
	BRNE _0x53
; 0000 00AC           {
; 0000 00AD           if(regimA==1){if(bufer>=100){bufer=0;}}
	LDI  R30,LOW(1)
	CP   R30,R9
	BRNE _0x54
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x64)
	BRLO _0x55
	RCALL SUBOPT_0x9
_0x55:
; 0000 00AE           if(regimA==2){if(bufer>=13){bufer=0;}}
_0x54:
	LDI  R30,LOW(2)
	CP   R30,R9
	BRNE _0x56
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0xD)
	BRLO _0x57
	RCALL SUBOPT_0x9
_0x57:
; 0000 00AF           if(regimA==3){if(bufer>=32){bufer=0;}}
_0x56:
	LDI  R30,LOW(3)
	CP   R30,R9
	BRNE _0x58
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x20)
	BRLO _0x59
	RCALL SUBOPT_0x9
_0x59:
; 0000 00B0           }
_0x58:
; 0000 00B1 
; 0000 00B2        }
_0x53:
; 0000 00B3        if(PINB.0==0&PINB.1==1)   //   
_0x47:
	RCALL SUBOPT_0xA
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(1)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0x5A
; 0000 00B4        {
; 0000 00B5         bufer=0;
	RCALL SUBOPT_0x9
; 0000 00B6         if(regimA==3){regimA=0;}      //  
	LDI  R30,LOW(3)
	CP   R30,R9
	BRNE _0x5B
	CLR  R9
; 0000 00B7         else(regimA++);
	RJMP _0x5C
_0x5B:
	INC  R9
; 0000 00B8         while(PINB.0==0&PINB.1==1){} //   
_0x5C:
_0x5D:
	RCALL SUBOPT_0xA
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(1)
	RCALL __EQB12
	AND  R30,R0
	BRNE _0x5D
; 0000 00B9        }
; 0000 00BA 
; 0000 00BB 
; 0000 00BC        while(regim==0)// . , ,    . .
_0x5A:
	TST  R6
	BRNE _0x62
; 0000 00BD        {
; 0000 00BE         mig=0,mig1=0;mig2=0;
	CBI  0x13,0
	CBI  0x13,1
	CBI  0x13,2
; 0000 00BF         rtc_get_time(&hour,&minuti,&second); //   ds1307  
	RCALL SUBOPT_0xF
; 0000 00C0         if(second>50)                      //      50 :
	LDI  R30,LOW(50)
	CP   R30,R5
	BRSH _0x69
; 0000 00C1          {
; 0000 00C2          rtc_get_date(&date,&month,&year); //   ds1307  
	RCALL SUBOPT_0x5
; 0000 00C3          hor=date;min=month;sec=year;      //    
	RCALL SUBOPT_0x10
; 0000 00C4          }
; 0000 00C5          else
	RJMP _0x6A
_0x69:
; 0000 00C6          {
; 0000 00C7          hor=hour;min=minuti;sec=second;    //    
	MOV  R13,R3
	MOV  R12,R2
	STS  _sec,R5
; 0000 00C8          }
_0x6A:
; 0000 00C9          if(tabkod[11]==hour & tabkod[10]==minuti & second==0){Play=1;}//    .    . 
	__POINTW2MN _tabkod,11
	RCALL __EEPROMRDB
	MOV  R26,R30
	MOV  R30,R3
	RCALL __EQB12
	MOV  R0,R30
	RCALL SUBOPT_0x11
	MOV  R26,R30
	MOV  R30,R2
	RCALL __EQB12
	AND  R0,R30
	MOV  R26,R5
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0x6B
	SBI  0x13,3
; 0000 00CA          if(minuti>tabkod[10]+5){Play=0;} //  5 .  .
_0x6B:
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xC
	ADIW R30,5
	MOV  R26,R2
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x6E
	CBI  0x13,3
; 0000 00CB 
; 0000 00CC 
; 0000 00CD          break;
_0x6E:
; 0000 00CE        }
_0x62:
; 0000 00CF 
; 0000 00D0        while(regim==1)  //   
	LDI  R30,LOW(1)
	CP   R30,R6
	BRNE _0x73
; 0000 00D1        {
; 0000 00D2           switch(regimA)
	RCALL SUBOPT_0x12
; 0000 00D3           {
; 0000 00D4           case 0:min=tabkod[11];sec=tabkod[10];mig=1;break;//    
	BRNE _0x77
	__POINTW2MN _tabkod,11
	RCALL __EEPROMRDB
	MOV  R12,R30
	RCALL SUBOPT_0x11
	STS  _sec,R30
	SBI  0x13,0
	RJMP _0x76
; 0000 00D5           case 1:sec=minuti=bufer;mig=1;mig1=0;mig2=!mig2;break;//    
_0x77:
	RCALL SUBOPT_0x13
	BRNE _0x7A
	RCALL SUBOPT_0xD
	MOV  R2,R30
	STS  _sec,R30
	SBI  0x13,0
	CBI  0x13,1
	SBIS 0x13,2
	RJMP _0x7F
	CBI  0x13,2
	RJMP _0x80
_0x7F:
	SBI  0x13,2
_0x80:
	RJMP _0x76
; 0000 00D6           case 2:min=hour=bufer;mig=1;mig1=!mig1;mig2=0;break;//    
_0x7A:
	RCALL SUBOPT_0x14
	BRNE _0x81
	RCALL SUBOPT_0xD
	MOV  R3,R30
	MOV  R12,R30
	SBI  0x13,0
	SBIS 0x13,1
	RJMP _0x84
	CBI  0x13,1
	RJMP _0x85
_0x84:
	SBI  0x13,1
_0x85:
	RJMP _0xD2
; 0000 00D7           case 3:tabkod[11]=hour;tabkod[10]=minuti;mig1=0;mig2=0;break;//    
_0x81:
	RCALL SUBOPT_0x15
	BRNE _0x76
	__POINTW2MN _tabkod,11
	MOV  R30,R3
	RCALL __EEPROMWRB
	__POINTW2MN _tabkod,10
	MOV  R30,R2
	RCALL __EEPROMWRB
	CBI  0x13,1
_0xD2:
	CBI  0x13,2
; 0000 00D8           }
_0x76:
; 0000 00D9          break;
; 0000 00DA        }
_0x73:
; 0000 00DB 
; 0000 00DC        while(regim==2)  //   
	LDI  R30,LOW(2)
	CP   R30,R6
	BRNE _0x8F
; 0000 00DD        {
; 0000 00DE           switch(regimA)
	RCALL SUBOPT_0x12
; 0000 00DF           {
; 0000 00E0           case 0:rtc_get_time(&hour,&minuti,&second);hor=hour;min=minuti;mig=0;mig1=0;mig2=1;break;//    
	BRNE _0x93
	RCALL SUBOPT_0xF
	MOV  R13,R3
	MOV  R12,R2
	RJMP _0xD3
; 0000 00E1           case 1:min=minuti=bufer;mig=0;mig1=!mig1;mig2=1;break;//    
_0x93:
	RCALL SUBOPT_0x13
	BRNE _0x9A
	RCALL SUBOPT_0xD
	MOV  R2,R30
	MOV  R12,R30
	CBI  0x13,0
	SBIS 0x13,1
	RJMP _0x9D
	CBI  0x13,1
	RJMP _0x9E
_0x9D:
	SBI  0x13,1
_0x9E:
	RJMP _0xD4
; 0000 00E2           case 2:hor=hour=bufer;mig=!mig;mig1=0;mig2=1;break;//    
_0x9A:
	RCALL SUBOPT_0x14
	BRNE _0xA1
	RCALL SUBOPT_0xD
	MOV  R3,R30
	MOV  R13,R30
	SBIS 0x13,0
	RJMP _0xA2
	CBI  0x13,0
	RJMP _0xA3
_0xA2:
	SBI  0x13,0
_0xA3:
	RJMP _0xD5
; 0000 00E3           case 3:rtc_set_time(hour,minuti,0);mig=0;mig1=0;mig2=1;break;//    1307
_0xA1:
	RCALL SUBOPT_0x15
	BRNE _0x92
	ST   -Y,R3
	ST   -Y,R2
	RCALL SUBOPT_0x4
	RCALL _rtc_set_time
_0xD3:
	CBI  0x13,0
_0xD5:
	CBI  0x13,1
_0xD4:
	SBI  0x13,2
; 0000 00E4           }
_0x92:
; 0000 00E5          break;
; 0000 00E6        }
_0x8F:
; 0000 00E7 
; 0000 00E8        while(regim==3)  //  
	LDI  R30,LOW(3)
	CP   R30,R6
	BRNE _0xB1
; 0000 00E9         {
; 0000 00EA 
; 0000 00EB           switch(regimA)
	RCALL SUBOPT_0x12
; 0000 00EC           {
; 0000 00ED           case 0:hor=date;min=month;sec=year;mig=0;mig1=0;mig2=0;break;//    
	BRNE _0xB5
	RCALL SUBOPT_0x10
	CBI  0x13,0
	RJMP _0xD6
; 0000 00EE           case 1:sec=year=bufer;mig=0;mig1=0;mig2=!mig2;break;//    
_0xB5:
	RCALL SUBOPT_0x13
	BRNE _0xBC
	RCALL SUBOPT_0xD
	MOV  R10,R30
	STS  _sec,R30
	CBI  0x13,0
	CBI  0x13,1
	SBIS 0x13,2
	RJMP _0xC1
	CBI  0x13,2
	RJMP _0xC2
_0xC1:
	SBI  0x13,2
_0xC2:
	RJMP _0xB4
; 0000 00EF           case 2:min=month=bufer;mig=0;mig1=!mig1;mig2=0;break;//    
_0xBC:
	RCALL SUBOPT_0x14
	BRNE _0xC3
	RCALL SUBOPT_0xD
	MOV  R11,R30
	MOV  R12,R30
	CBI  0x13,0
	SBIS 0x13,1
	RJMP _0xC6
	CBI  0x13,1
	RJMP _0xC7
_0xC6:
	SBI  0x13,1
_0xC7:
	RJMP _0xD7
; 0000 00F0           case 3:hor=date=bufer;rtc_set_date(date,month,year);mig=!mig;mig1=0;mig2=0;break;//    1307
_0xC3:
	RCALL SUBOPT_0x15
	BRNE _0xB4
	RCALL SUBOPT_0xD
	MOV  R8,R30
	MOV  R13,R30
	ST   -Y,R8
	ST   -Y,R11
	ST   -Y,R10
	RCALL _rtc_set_date
	SBIS 0x13,0
	RJMP _0xCB
	CBI  0x13,0
	RJMP _0xCC
_0xCB:
	SBI  0x13,0
_0xCC:
_0xD6:
	CBI  0x13,1
_0xD7:
	CBI  0x13,2
; 0000 00F1           }
_0xB4:
; 0000 00F2          break;
; 0000 00F3         }
_0xB1:
; 0000 00F4         count=0;
	LDI  R30,LOW(0)
	STS  _count,R30
	STS  _count+1,R30
; 0000 00F5         break;
; 0000 00F6        }
_0x40:
; 0000 00F7 
; 0000 00F8       }
	RJMP _0x2E
; 0000 00F9 
; 0000 00FA 
; 0000 00FB }
_0xD1:
	RJMP _0xD1
;
;

	.CSEG
_rtc_init:
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2000003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2000003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2000004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2000004:
	RCALL SUBOPT_0x16
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x17
	LDD  R30,Y+2
	RJMP _0x2040003
_rtc_get_time:
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x4
	RCALL _i2c_write
	RCALL _i2c_start
	LDI  R30,LOW(209)
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	LD   R26,Y
	ST   X,R30
	RCALL SUBOPT_0x18
	LDD  R26,Y+1
	ST   X,R30
	RCALL SUBOPT_0x4
	RCALL _i2c_read
	ST   -Y,R30
	RCALL _bcd2bin
	LDD  R26,Y+2
	ST   X,R30
	RJMP _0x2040001
_rtc_set_time:
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x4
	RCALL _i2c_write
	LD   R30,Y
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x17
	LDD  R30,Y+1
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x17
	LDD  R30,Y+2
	RJMP _0x2040002
_rtc_get_date:
	RCALL SUBOPT_0x16
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x17
	RCALL _i2c_start
	LDI  R30,LOW(209)
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	LDD  R26,Y+2
	ST   X,R30
	RCALL SUBOPT_0x18
	LDD  R26,Y+1
	ST   X,R30
	RCALL SUBOPT_0x4
	RCALL _i2c_read
	ST   -Y,R30
	RCALL _bcd2bin
	LD   R26,Y
	ST   X,R30
	RJMP _0x2040001
_rtc_set_date:
	RCALL SUBOPT_0x16
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x17
	LDD  R30,Y+2
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x17
	LDD  R30,Y+1
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x17
	LD   R30,Y
_0x2040002:
	ST   -Y,R30
	RCALL _bin2bcd
_0x2040003:
	ST   -Y,R30
	RCALL _i2c_write
_0x2040001:
	RCALL _i2c_stop
	ADIW R28,3
	RET

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.ESEG
_tabkod:
	.DB  LOW(0x13B3A383),HIGH(0x13B3A383),BYTE3(0x13B3A383),BYTE4(0x13B3A383)
	.DB  LOW(0x3436323),HIGH(0x3436323),BYTE3(0x3436323),BYTE4(0x3436323)
	.DB  LOW(0x9333),HIGH(0x9333),BYTE3(0x9333),BYTE4(0x9333)
	.DB  0x0

	.DSEG
_sec:
	.BYTE 0x1
_count:
	.BYTE 0x2
_bufer:
	.BYTE 0x1
_T1Reload:
	.BYTE 0x2
_index:
	.BYTE 0x2
_lang:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	RJMP _bin2bcd

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(240)
	AND  R4,R30
	MOV  R30,R4
	LDI  R31,0
	RCALL __ASRW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x2:
	LDI  R27,0
	SUBI R26,LOW(-_tabkod)
	SBCI R27,HIGH(-_tabkod)
	RCALL __EEPROMRDB
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(127)
	OUT  0x12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	RJMP _rtc_get_date

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	STS  _index,R30
	STS  _index+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8:
	LDI  R26,0
	SBIC 0x16,0
	LDI  R26,1
	LDI  R30,LOW(0)
	RCALL __EQB12
	MOV  R0,R30
	LDI  R26,0
	SBIC 0x16,1
	LDI  R26,1
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	STS  _bufer,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	LDI  R26,0
	SBIC 0x16,0
	LDI  R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xB:
	RCALL __EQB12
	MOV  R0,R30
	LDI  R26,0
	SBIC 0x16,1
	LDI  R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDS  R30,_bufer
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	LDS  R26,_bufer
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	RJMP _rtc_get_time

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	MOV  R13,R8
	MOV  R12,R11
	STS  _sec,R10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	__POINTW2MN _tabkod,10
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	MOV  R30,R9
	RCALL SUBOPT_0xC
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x14:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x16:
	RCALL _i2c_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x17:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _i2c_read
	ST   -Y,R30
	RJMP _bcd2bin


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
